'use strict';
const ManagerController = require('../manager.js');
/**
 * [exports 产品品牌]
 * @type {[type]}
 */
module.exports = class ProductBrandsController extends ManagerController {
    /**
     * [useModel 使用模型]
     * @return {[type]} [description]
     */
    get useModel() {
        let that = this;
        return that.app.model.ProductBrands;
    }
    /**
     * [createValidate 添加品牌]
     * @return {[type]} [description]
     */
    get createValidate() {
    	let that = this;
    	return {
    		brand_name:that.ctx.rules.name('品牌名称').required().notEmpty().trim(),
    		brand_logo:that.ctx.rules.default('').required(),
            admin_id:that.ctx.rules.default(that.service.manager.ActionAdminUserId()).number(),
            create_time:that.ctx.rules.default(that.app.szjcomo.date('Y-m-d H:i:s')).required()
    	};
    }
    /**
     * [deleteValidate 删除品牌]
     * @return {[type]} [description]
     */
    get deleteValidate() {
    	let that = this;
    	return {
    		brand_id:that.ctx.rules.name('品牌ID').required().notEmpty().number().extend(async (field,value,row) => {
    			let productsCount = await that.app.model.Products.findOne({where:{brand_id:value},attributes:['product_id']});
    			if(productsCount) return '当前品牌下还有商品,无法删除';
    		})
    	};
    }
    /**
     * [selectOptions 商品品牌查询条件]
     * @param  {Object} data [description]
     * @return {[type]}      [description]
     */
    async selectOptions(data = {}) {
        let that = this;
        let options = {offset:(data.page - 1) * data.limit,limit:data.limit,include:[
            {model:that.app.model.AdminUser,as:'admin_user',attributes:[]}
        ],attributes:{
            exclude:['admin_id'],
            include:[[that.app.Sequelize.col('admin_user.username'),'username']]
        },order:[['brand_id','desc']]};
        return options;
    }


}