/* indent size: 2 */
'use strict';

module.exports = app => {
  const DataTypes = app.Sequelize;

  const Model = app.model.define('ProductTypes', {
    type_id: {
      type: DataTypes.INTEGER(10).UNSIGNED,
      allowNull: false,
      primaryKey: true,
      autoIncrement: true,
    },
    type_name: {
      type: DataTypes.STRING(255),
      allowNull: true,
    },
    admin_id: {
      type: DataTypes.INTEGER(10).UNSIGNED,
      allowNull: true,
    },
    update_time: {
      type: DataTypes.TIME,
      allowNull: true,
    },
    create_time: {
      type: DataTypes.DATE,
      allowNull: true,
    },
  }, {
    tableName: 'szj_product_types',
  });

  Model.associate = function() {
    // 关联管理员表
    Model.belongsTo(app.model.AdminUser, { foreignKey: 'admin_id', targetKey: 'admin_id', as: 'admin_user' });
    // 关联属性表
    Model.hasMany(app.model.ProductTypesItem, {
      foreignKey: 'type_id',
      targetKey: 'type_id',
      as: 'product_types_item',
    });
  };
  // 同步:没有就新建,有就不变
  Model.sync();
  return Model;
};
